Index: src/uk/me/parabola/imgfmt/app/labelenc/AnyCharsetEncoder.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/labelenc/AnyCharsetEncoder.java	(revision 4816)
+++ src/uk/me/parabola/imgfmt/app/labelenc/AnyCharsetEncoder.java	(working copy)
@@ -26,6 +26,8 @@
 import java.util.Arrays;
 import java.util.Locale;
 
+import uk.me.parabola.log.Logger;
+
 /**
  * Convert text to a specified charset.  This is used when you give a
  * charset name on the command line to convert to.
@@ -68,7 +70,6 @@
 		CharBuffer charBuffer = CharBuffer.wrap(ucText);
 
 		CoderResult result;
-
 		do {
 			result = encoder.encode(charBuffer, outBuf, true);
 
@@ -76,9 +77,9 @@
 				// There is a character that cannot be represented in the target code page.
 				// Read the character(s), transliterate them, and add them to the output.
 				// We then continue onward with the rest of the string.
-				String s;
+				String s0;
 				if (result.length() == 1) {
-					s = String.valueOf(charBuffer.get());
+					s0 = String.valueOf(charBuffer.get());
 				} else {
 					// Don't know under what circumstances this will be called and may not be the
 					// correct thing to do when it does happen.
@@ -86,17 +87,23 @@
 					for (int i = 0; i < result.length(); i++)
 						sb.append(charBuffer.get());
 
-					s = sb.toString();
+					s0 = sb.toString();
 				}
 
-				s = transliterator.transliterate(s);
+				String s = transliterator.transliterate(s0);
 
 				// Make sure that there is enough space for the transliterated string
 				while (outBuf.limit() < outBuf.position() + s.length())
 					outBuf = reallocBuf(outBuf);
 
-				for (int i = 0; i < s.length(); i++)
-					outBuf.put((byte) s.charAt(i));
+				if (s.equals(s0)) {
+					// string was not transliterated
+					outBuf.put((byte) '?');
+				} else {
+					for (int i = 0; i < s.length(); i++) {
+						outBuf.put((byte) s.charAt(i));
+					}
+				}
 
 			} else if (result == CoderResult.OVERFLOW) {
 				// Ran out of space in the output
@@ -111,7 +118,7 @@
 		char[] cres = new char[outBuf.position()];
 		for (int i = 0; i < outBuf.position(); i++)
 			cres[i] = (char) (res[i] & 0xff);
-		return new EncodedText(res, res.length, cres);
+		return new EncodedText(res, res.length, cres); 
 	}
 
 	/**
